#include <iostream>
#include <stdexcept>

#include "vektor.h"


vektor::vektor(int potenKapacita)
{
	kapacita = potenKapacita;
	this->poten_kapacita = potenKapacita;
	posledn = -1;
	pole = new T[kapacita];
	poet_vektor++;
}

vektor::~vektor()
{
	delete[] pole;
	std::cout << "destrukce" << std::endl;
	poet_vektor--;
}

void vektor::pidej_na_konec(T co)
{
	if (++posledn == kapacita)
	{
		T* pom = pole;
		kapacita *= 2;
		pole = new T[kapacita];
		pekopruj(pom, pole, posledn + 1);
		delete[] pom;
	}
	pole[posledn] = co;
}

void vektor::vpis()
{
	for (int i = 0; i <= posledn; i++)
	{
		std::cout << pole[i] << " ";
	}
	std::cout << std::endl;
}

void vektor::vyprzdni()
{
	posledn = -1;
}

void vektor::vyprzdni_a_zkra()
{
	vyprzdni();
	delete[] pole;
	pole = new T[poten_kapacita];
	kapacita = poten_kapacita;
}



T& vektor::prvek(int index)
{
	if (index < 0 || index > posledn)
	{
		throw std::out_of_range("Index vektoru mimo rozsah");
	}
	return pole[index];
}

T& vektor::operator[](int index)
{
	if (index < 0 || index > posledn)
	{
		throw std::out_of_range("Index vektoru mimo rozsah");
	}
	return pole[index];
}

size_t vektor::velikost()
{
	return posledn + 1;
}

bool vektor::przdn()
{
	return posledn == -1;
}

size_t vektor::poet()
{
	return poet_vektor;
}

void vektor::pekopruj(T* odkud, T* kam, int kolik)
{
	for (int i = 0; i < kolik; i++)
	{
		kam[i] = odkud[i];
	}
}

size_t vektor::poet_vektor = 0;
